/*
 * $Header: /cvsroot/jaxen/jaxen/src/java/main/org/jaxen/expr/DefaultTruthExpr.java,v 1.6 2003/06/29 18:05:40 ssanders Exp $
 * $Revision: 1.6 $
 * $Date: 2003/06/29 18:05:40 $
 *
 * ====================================================================
 *
 * Copyright (C) 2000-2002 bob mcwhirter & James Strachan.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions, and the following disclaimer.
 *
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions, and the disclaimer that follows 
 *    these conditions in the documentation and/or other materials 
 *    provided with the distribution.
 *
 * 3. The name "Jaxen" must not be used to endorse or promote products
 *    derived from this software without prior written permission.  For
 *    written permission, please contact license@jaxen.org.
 * 
 * 4. Products derived from this software may not be called "Jaxen", nor
 *    may "Jaxen" appear in their name, without prior written permission
 *    from the Jaxen Project Management (pm@jaxen.org).
 * 
 * In addition, we request (but do not require) that you include in the 
 * end-user documentation provided with the redistribution and/or in the 
 * software itself an acknowledgement equivalent to the following:
 *     "This product includes software developed by the
 *      Jaxen Project (http://www.jaxen.org/)."
 * Alternatively, the acknowledgment may be graphical using the logos 
 * available at http://www.jaxen.org/
 *
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
 * DISCLAIMED.  IN NO EVENT SHALL THE Jaxen AUTHORS OR THE PROJECT
 * CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF
 * USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY,
 * OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
 * OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 * ====================================================================
 * This software consists of voluntary contributions made by many 
 * individuals on behalf of the Jaxen Project and was originally 
 * created by bob mcwhirter <bob@werken.com> and 
 * James Strachan <jstrachan@apache.org>.  For more information on the 
 * Jaxen Project, please see <http://www.jaxen.org/>.
 * 
 * $Id: DefaultTruthExpr.java,v 1.6 2003/06/29 18:05:40 ssanders Exp $
 */



package org.jaxen.expr;

import java.util.List;

abstract class DefaultTruthExpr extends DefaultBinaryExpr 
{
    public DefaultTruthExpr(Expr lhs,
                            Expr rhs)
    {
        super( lhs,
               rhs );
    }

    public String toString()
    {
        return "[(DefaultTruthExpr): " + getLHS() + ", " + getRHS() + "]";
    }

    protected boolean bothAreSets(Object lhs,
                                  Object rhs)
    {
        return ( lhs instanceof List
                 &&
                 rhs instanceof List );
    }

    protected boolean eitherIsSet(Object lhs,
                                  Object rhs)
    {
        return ( lhs instanceof List
                 ||
                 rhs instanceof List );
    }

    protected boolean isSet(Object obj)
    {
        return ( obj instanceof List );
    }
    
    protected boolean setIsEmpty( List set )
      {
      return (set == null || set.size() == 0);
      }

    protected boolean eitherIsBoolean(Object lhs,
                                      Object rhs)
    {
        return ( lhs instanceof Boolean
                 ||
                 rhs instanceof Boolean );
    }

    protected boolean bothAreBoolean(Object lhs,
                                     Object rhs)
    {
        return ( lhs instanceof Boolean
                 &&
                 rhs instanceof Boolean );
    }

    protected boolean eitherIsNumber(Object lhs,
                                     Object rhs)
    {
        return ( lhs instanceof Number
                 ||
                 rhs instanceof Number );
    }

    protected boolean isNumber(Object obj)
    {
        return ( obj instanceof Number );
    }

    protected boolean isString(Object obj)
    {
        return ( obj instanceof String );
    }

    protected boolean isBoolean(Object obj)
    {
        return ( obj instanceof Boolean );
    }
}

